#include <iostream>
#include <fstream>
#include <vector>
using namespace std;
typedef unsigned char BYTE;

void writeBinaryVector(vector<bool> bVect, string filename){

	unsigned int length = bVect.size();
	unsigned tmp = length;
	char byte1 = (tmp / 65536) ;

	tmp = tmp % 65536;
	char byte2 = tmp / 256;
	char a = tmp;
	ofstream file (filename, ios::out|ios::binary);
	file << byte1 << byte2 << a; //<< char(64);
	unsigned bytes = (length + 7) / 8;
	for (int i =0; i < 8; i++) {bVect.push_back(false);}
	for (unsigned b = 0; b < bytes; b++){

		// construct byte and write to file;
		unsigned char mask = 128;
		unsigned char currentByte = 0;
		for (int bit = 0; bit < 8; bit++){
			//cout << "bit = " << bit << endl;
			if (bVect[(b * 8) + bit] == true){
				cout << "yes\n";
				currentByte = currentByte | mask;
			}
			mask = mask / 2;
		}
		file << currentByte;
	}
	file.close();



}




vector<bool> readBinaryVector (string filename) {
  ifstream::pos_type size;
  BYTE * memblock;
  vector<bool> result ;
  ifstream file (filename, ios::in|ios::binary|ios::ate);
  if (file.is_open())
  {
    size = file.tellg();
    memblock = new  BYTE [size];
    file.seekg (0, ios::beg);
    file.read ((char *) memblock, size);
    file.close();
    int foo1 = memblock[0];
    int foo2 = memblock[1];
    int foo3 = memblock[2];
    int numBits = foo1 * 65536 + foo2 * 256 + foo3;
    //cout << numBits << endl;
    int bitCounter = 0;
    for (int i = 3; i < size; i++){
    	//cout << (int)memblock[i] << endl;
    	unsigned char curChar = memblock[i];
    	unsigned int column = 128;
    	while ((column > 0) && (bitCounter < numBits)){
    		bitCounter++;
    		if (curChar >= column){
    			result.push_back(true);
    			//cout << "true" << endl;
    			curChar -= column;
    		}
    		else {
    			result.push_back(false);
    		}
    		column = column / 2;
    	}
    	

    }
    cout << "the complete file content is in memory" << endl;
    cout << "SIZE " << result.size() << endl;
    for (int i = 0; i < result.size(); i++){
		cout << result[i] << endl;
	}
    // now convert to bits


    delete[] memblock;
  }
  else cout << "Unable to open file";
  return result;
}

int main(){

	char ch;
	unsigned int iChar;
	vector<bool> bitText;
	// first in my demo is to read characters from standard
	// in to a vector of bool. ('a' = 1, 'b' = 2, etc. except for
	// space which will be represented by 31)
	while (cin.get(ch)){
		cout << ch << endl;
		// convert
		if (ch == 32){
			iChar=31;
			cout << "SPACE\n";
		}
		else if ((ch >= 'A') && (ch <= 'Z')){
			iChar = ch - 65;
		}
		for (int i = 16; i > 0; i = i / 2){
			if (iChar >= i){
				bitText.push_back(true);
				iChar -= i;
			}
			else{
				bitText.push_back(false);
			}
		}
	}

	//vector<bool> bV{true, true, true, false, false, false, false, true, true, true};
	// now I am going to write the bool vector into a binary file.
	writeBinaryVector(bitText, "text.bin");
	vector <bool> bV2;
	bV2 = readBinaryVector("text.bin");

	cout << "SIZE " << bV2.size() << endl;

	for (int i = 0; i < bV2.size(); i++){
		if ((i % 5) == 0){

			cout << endl;
		}

		cout << bV2[i];
		
	}

}